searchData={"items":[{"type":"module","title":"ftpfilez","doc":"FTPS file storage. Can put, get and stream files from FTP servers. Similar interface as s3filez.","ref":"ftpfilez.html"},{"type":"function","title":"ftpfilez.create_bucket/2","doc":"Create a private bucket (aka directory) at the URL.","ref":"ftpfilez.html#create_bucket/2"},{"type":"function","title":"ftpfilez.create_bucket/3","doc":"Create a bucket at the URL, with acl options.","ref":"ftpfilez.html#create_bucket/3"},{"type":"function","title":"ftpfilez.delete/2","doc":"Delete the file at the url.","ref":"ftpfilez.html#delete/2"},{"type":"function","title":"ftpfilez.get/2","doc":"Fetch the data at the url.","ref":"ftpfilez.html#get/2"},{"type":"function","title":"ftpfilez.put/3","doc":"Put a binary or file to the given url.","ref":"ftpfilez.html#put/3"},{"type":"function","title":"ftpfilez.put/4","doc":"Put a binary or file to the given url. Set options for acl. Ensures that the directory of the file is present by recursively creating the sub directories.","ref":"ftpfilez.html#put/4"},{"type":"function","title":"ftpfilez.queue_delete/2","doc":"Async delete a file on S3","ref":"ftpfilez.html#queue_delete/2"},{"type":"function","title":"ftpfilez.queue_delete/3","doc":"Async delete a file on S3, call ready_fun when ready.","ref":"ftpfilez.html#queue_delete/3"},{"type":"function","title":"ftpfilez.queue_delete_id/4","doc":"Queue a named file deletion process, call ready_fun when ready.","ref":"ftpfilez.html#queue_delete_id/4"},{"type":"function","title":"ftpfilez.queue_get/3","doc":"Queue a file dowloader and call ready_fun when finished.","ref":"ftpfilez.html#queue_get/3"},{"type":"function","title":"ftpfilez.queue_get_id/4","doc":"Queue a named file dowloader and call ready_fun when finished. Names must be unique, duplicates are refused with &lt;tt&gt;{error, {already_started, _}}&lt;/tt&gt;.","ref":"ftpfilez.html#queue_get_id/4"},{"type":"function","title":"ftpfilez.queue_put/3","doc":"Queue a file uploader. The data can be a binary or a filename.","ref":"ftpfilez.html#queue_put/3"},{"type":"function","title":"ftpfilez.queue_put/4","doc":"Queue a file uploader and call ready_fun when finished.","ref":"ftpfilez.html#queue_put/4"},{"type":"function","title":"ftpfilez.queue_put/5","doc":"Queue a file uploader and call ready_fun when finished. Options include the &lt;tt&gt;acl&lt;/tt&gt; setting and &lt;tt&gt;content_type&lt;/tt&gt; for the file.","ref":"ftpfilez.html#queue_put/5"},{"type":"function","title":"ftpfilez.queue_put_id/5","doc":"Start a named file uploader. Names must be unique, duplicates are refused with &lt;tt&gt;{error, {already_started, _}}&lt;/tt&gt;.","ref":"ftpfilez.html#queue_put_id/5"},{"type":"function","title":"ftpfilez.queue_stream/3","doc":"Queue a file downloader that will stream chunks to the given stream_fun. The default block size for the chunks is 64KB.","ref":"ftpfilez.html#queue_stream/3"},{"type":"function","title":"ftpfilez.queue_stream_id/4","doc":"Queue a named file downloader that will stream chunks to the given stream_fun. The default block size for the chunks is 64KB.","ref":"ftpfilez.html#queue_stream_id/4"},{"type":"function","title":"ftpfilez.stream/3","doc":"Stream the contents of the url to the function, callback or Pid.","ref":"ftpfilez.html#stream/3"},{"type":"type","title":"ftpfilez.acl_type/0","doc":null,"ref":"ftpfilez.html#t:acl_type/0"},{"type":"type","title":"ftpfilez.config/0","doc":null,"ref":"ftpfilez.html#t:config/0"},{"type":"type","title":"ftpfilez.put_data/0","doc":null,"ref":"ftpfilez.html#t:put_data/0"},{"type":"type","title":"ftpfilez.put_opt/0","doc":null,"ref":"ftpfilez.html#t:put_opt/0"},{"type":"type","title":"ftpfilez.put_opts/0","doc":null,"ref":"ftpfilez.html#t:put_opts/0"},{"type":"type","title":"ftpfilez.queue_reply/0","doc":null,"ref":"ftpfilez.html#t:queue_reply/0"},{"type":"type","title":"ftpfilez.ready_fun/0","doc":null,"ref":"ftpfilez.html#t:ready_fun/0"},{"type":"type","title":"ftpfilez.stream_fun/0","doc":null,"ref":"ftpfilez.html#t:stream_fun/0"},{"type":"type","title":"ftpfilez.sync_reply/0","doc":null,"ref":"ftpfilez.html#t:sync_reply/0"},{"type":"type","title":"ftpfilez.url/0","doc":null,"ref":"ftpfilez.html#t:url/0"},{"type":"module","title":"ftpfilez_app","doc":"Main app code. Start the supervisor for the queued jobs.","ref":"ftpfilez_app.html"},{"type":"function","title":"ftpfilez_app.start/2","doc":null,"ref":"ftpfilez_app.html#start/2"},{"type":"function","title":"ftpfilez_app.stop/1","doc":null,"ref":"ftpfilez_app.html#stop/1"},{"type":"module","title":"ftpfilez_ftps","doc":"Place a data file on a FTP(S) server, list home directory, or fetch a file. The fetched file can be streamed.","ref":"ftpfilez_ftps.html"},{"type":"function","title":"ftpfilez_ftps.delete/2","doc":null,"ref":"ftpfilez_ftps.html#delete/2"},{"type":"function","title":"ftpfilez_ftps.download/2","doc":null,"ref":"ftpfilez_ftps.html#download/2"},{"type":"function","title":"ftpfilez_ftps.list/1","doc":null,"ref":"ftpfilez_ftps.html#list/1"},{"type":"function","title":"ftpfilez_ftps.mkdir/2","doc":null,"ref":"ftpfilez_ftps.html#mkdir/2"},{"type":"function","title":"ftpfilez_ftps.stream/3","doc":null,"ref":"ftpfilez_ftps.html#stream/3"},{"type":"function","title":"ftpfilez_ftps.upload/3","doc":null,"ref":"ftpfilez_ftps.html#upload/3"},{"type":"function","title":"ftpfilez_ftps.vsftpd_tls/2","doc":null,"ref":"ftpfilez_ftps.html#vsftpd_tls/2"},{"type":"type","title":"ftpfilez_ftps.config/0","doc":null,"ref":"ftpfilez_ftps.html#t:config/0"},{"type":"module","title":"ftpfilez_job","doc":"Async queued job, scheduled by jobs and supervised by ftpfilez_sup.","ref":"ftpfilez_job.html"},{"type":"function","title":"ftpfilez_job.code_change/3","doc":null,"ref":"ftpfilez_job.html#code_change/3"},{"type":"function","title":"ftpfilez_job.handle_call/3","doc":null,"ref":"ftpfilez_job.html#handle_call/3"},{"type":"function","title":"ftpfilez_job.handle_cast/2","doc":null,"ref":"ftpfilez_job.html#handle_cast/2"},{"type":"function","title":"ftpfilez_job.handle_info/2","doc":null,"ref":"ftpfilez_job.html#handle_info/2"},{"type":"function","title":"ftpfilez_job.init/1","doc":null,"ref":"ftpfilez_job.html#init/1"},{"type":"function","title":"ftpfilez_job.start_link/2","doc":null,"ref":"ftpfilez_job.html#start_link/2"},{"type":"function","title":"ftpfilez_job.terminate/2","doc":null,"ref":"ftpfilez_job.html#terminate/2"},{"type":"module","title":"ftpfilez_jobs_sup","doc":"Supervisor for all s3 async queued jobs.","ref":"ftpfilez_jobs_sup.html"},{"type":"function","title":"ftpfilez_jobs_sup.init/1","doc":null,"ref":"ftpfilez_jobs_sup.html#init/1"},{"type":"function","title":"ftpfilez_jobs_sup.queue/1","doc":null,"ref":"ftpfilez_jobs_sup.html#queue/1"},{"type":"function","title":"ftpfilez_jobs_sup.queue/2","doc":null,"ref":"ftpfilez_jobs_sup.html#queue/2"},{"type":"function","title":"ftpfilez_jobs_sup.start_link/0","doc":null,"ref":"ftpfilez_jobs_sup.html#start_link/0"},{"type":"module","title":"ftpfilez_sup","doc":null,"ref":"ftpfilez_sup.html"},{"type":"function","title":"ftpfilez_sup.init/1","doc":null,"ref":"ftpfilez_sup.html#init/1"},{"type":"function","title":"ftpfilez_sup.start_link/0","doc":null,"ref":"ftpfilez_sup.html#start_link/0"},{"type":"extras","title":"README","doc":"[![Test](https://github.com/mworrell/ftpfilez/actions/workflows/test.yml/badge.svg)](https://github.com/mworrell/ftpfilez/actions/workflows/test.yml)\n\n[![Hex.pm Version](https://img.shields.io/hexpm/v/ftpfilez.svg)](https://hex.pm/packages/ftpfilez)\n[![Hex.pm Downloads](https://img.shields.io/hexpm/dt/ftpfilez.svg)](https://hex.pm/packages/ftpfilez)\n\nftpfilez\n=======\n\nReally simple FTPS client - only put, get and delete.\n\nThis client is used in combination with filezcache and zotonic.\n\nDistinction with other FTPS clients is:\n\n * Only get, put and delete are supported\n * put of files and/or binaries\n * get with optional streaming function, to be able to stream to the filezcache\n * simple jobs queue, using the 'jobs' scheduler\n * missing directories in the target path are automatically created\n\n**NOTA BENE** This client only supports FTPS, you really shouldn't use plain FTP anymore.\n\nExample\n-------\n\n```erlang\nrebar3 shell\n===> Verifying dependencies...\n===> Analyzing applications...\n===> Compiling ftpfilez\nErlang/OTP 23 [erts-11.1] [source] [64-bit] [smp:12:12] [ds:12:12:10] [async-threads:1] [hipe]\n\nEshell V11.1  (abort with ^G)\n1> application:ensure_all_started(ftpfilez).\n{ok,[jobs,ftpfilez]}\n2> Cfg = #{ username => <<\"anonymous\">>, password => <<\"test@example.com\">> }.\n{<<\"anonymous\">>, <<\"test@example.com\">>}\n3> ftpfilez:put(Cfg, <<\"ftps://ftp.example.com/LICENSE\">>, {filename, \"LICENSE\"}).\nok\n4> ftpfilez:stream(Cfg, <<\"ftps://ftp.example.com/LICENSE\">>, fun(X) -> io:format(\"!! ~p~n\", [X]) end).\n!! stream_start\n!! <<\"\\n    Apache License\\n\", ...>>\n!! eof\n5> ftpfilez:delete(Cfg, <<\"ftps://ftp.example.com/LICENSE\">>).\nok\n```\n\nRequest Queue\n-------------\n\nRequests can be queued. They will be placed in a supervisor and scheduled using https://github.com/uwiger/jobs\nThe current scheduler restricts the number of parallel S3 requests. The default maximum is 8.\n\nThe `get`, `put` and `delete` requests can be queued. A function or pid can be given as a callback for the job result.\nThe `stream` command can’t be queued: it is already running asynchronously.\n\nExample:\n\n```erlang\n6> {ok, ReqId, JobPid} = ftpfilez:queue_put(Cfg, <<\"ftps://ftp.example.com/LICENSE\">>, {filename, \"LICENSE\"}, fun(ReqId,Result) -> io:format(\"!! ~p~n\", [ Result ]) end).\n{ok,#Ref<0.0.0.3684>,<0.854.0>}\n```\n\nThe returned `JobPid` is the pid of the process in the ftpfilez queue supervisor.\nThe callback can be a function (arity 2), `{M,F,A}` or a pid.\n\nIf the callback is a pid then it will receive the message `{ftpfilez_done, ReqId, Result}`.","ref":"readme.html"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright [yyyy] [name of copyright owner]\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}